<script lang="ts">
import Vue from 'vue';
import { cloneDeep } from 'lodash';
import { SlpSpinner } from '../common/index.vue';
import FeaturesProductsCategoryCards from './features-product-category-cards.vue';
// import FeaturesCtaSection from './features-cta-section.vue';
import { processFeatureObjectHelper } from '~/lib/processFeaturesHelper';

export default Vue.extend({
  name: 'FeaturesContent',
  components: {
    FeaturesProductsCategoryCards,
    // FeaturesCtaSection,
    SlpSpinner,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
    filter: {
      type: Object,
      required: true,
    },
    contentConfig: {
      type: Object,
      required: true,
    },
    selectedTab: {
      type: String,
      required: false,
      default: 'plan',
    },
  },
  data() {
    return {
      filteredData: [],
      isLoading: true,
    };
  },
  watch: {
    filter(newFilter: any) {
      this.isLoading = true;
      this.featuresByCategory(this.data, newFilter);
    },
  },
  beforeMount() {
    this.featuresByCategory(this.data, this.filter);
  },
  methods: {
    scrollToTop() {
      window.scrollTo({ top: 0, behavior: 'smooth' });
    },
    featuresByCategory(data: any, filter: any) {
      const clonedData = cloneDeep(data.features);
      this.filteredData = clonedData.map((item: any) => {
        return {
          ...item,
          features: item.features.map((feature: any) => {
            const itemCopy = processFeatureObjectHelper(
              feature,
              this.contentConfig,
            );
            itemCopy.with_opacity = this.processItemFilter(itemCopy, filter);
            return itemCopy;
          }),
        };
      });
      setTimeout(() => {
        this.isLoading = false;
      }, 1000);
    },
    processItemFilter(item: any, filter: any) {
      switch (filter.plan) {
        case 'free':
          return !item.isFree;
        case 'premium':
          return !item.isPremium;
        case 'ultimate':
          return !item.isUltimate;
        default:
          return false;
      }
    },
  },
});
</script>

<template>
  <div class="features-content">
    <section v-for="(category, index) in filteredData" :key="index">
      <div v-if="category.features.length">
        <div :id="category.slug" class="features-content__heading">
          <SlpTypography
            tag="h2"
            variant="heading4-bold"
            class="features-content__heading-name slp-mb-32"
          >
            {{ category.name }}
            <router-link
              :data-ga-features="selectedTab"
              :data-ga-features-sub="category.name.toLowerCase()"
              data-ga-location="features sub-section"
              :to="{
                behavior: 'smooth',
                path: '',
                query: { stage: selectedTab.toLowerCase() },
                hash: `${category.slug}`,
              }"
            >
              <SlpIcon
                icon="gl-link"
                alt="Icon"
                size="md"
                class="features-content__anchor-link"
              />
            </router-link>
          </SlpTypography>
          <SlpTypography
            v-if="category.description"
            class="slp-mb-64"
            tag="p"
            variant="body1"
          >
            {{ category.description }}
          </SlpTypography>
        </div>
        <FeaturesProductsCategoryCards
          class="features-content__products-category"
          :data="category.features"
          :tab-title="data.content"
          :column-size="contentConfig.column_size"
          :current-category="category.name"
          :image-base-path="`https://about.gitlab.com/images/feature_page/screenshots/`"
        />
        <!-- <FeaturesCtaSection
          :tab-title="data.content"
          :category-name="category.name"
        /> -->
      </div>
    </section>
    <SlpSpinner :is-loading="isLoading" />
  </div>
</template>

<style scoped lang="scss">
.features-content {
  margin-bottom: $spacing-96;
  margin-top: $spacing-48;
  padding-left: $spacing-4;
  padding-right: $spacing-4;
  position: relative;
  display: block;
  z-index: 1;
  &__heading {
    @media (min-width: $breakpoint-md) {
      max-width: calc(100% - 270px);
      padding-right: 32px;
    }

    &:before {
      pointer-events: none;
      content: '';
      display: block;
      height: 140px;
      margin: -140px 0 0;
    }
    &-name {
      display: inline-block;
      a {
        opacity: 0;
        transition: opacity 170ms ease;
        color: inherit;
        display: inline-block;
        padding-top: 17px;
      }
      &:hover,
      &:focus,
      &:active {
        a {
          opacity: 1;
          transition: opacity 170ms ease;
        }
      }
    }
  }
  &__missing-features-button {
    padding: 0;
    border: none;
    background: none;
    cursor: pointer;
    color: $color-text-link-100;
    font-size: $text-body-2;
    transition: all 0.5s ease;

    &:hover {
      filter: brightness(80%);
    }
  }

  &__products-category {
    padding: 0;
    opacity: 1;
    transition: opacity 0.3s ease-in-out;

    @media (min-width: $breakpoint-md) {
      margin-left: -$spacing-16;
    }

    &--loading {
      opacity: 0;
    }
  }

  &__btn {
    color: inherit;
    font-weight: bold;
    transition: all 0.5s ease-in-out;

    &:hover {
      text-decoration: underline;
    }
  }
  .header-anchor {
    display: inline-block;
  }
  &__anchor-link {
    width: 24px;
    height: 24px;
  }
}
</style>
